﻿define char01_sheet = "maze/01.png"
image char01 down:
    Crop((0, 0, 32, 32), char01_sheet)
    pause .2
    Crop((32, 0, 32, 32), char01_sheet)
    pause .2
    Crop((64, 0, 32, 32), char01_sheet)
    pause .2
    Crop((32, 0, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 up:
    Crop((0, 96, 32, 32), char01_sheet)
    pause .2
    Crop((32, 96, 32, 32), char01_sheet)
    pause .2
    Crop((64, 96, 32, 32), char01_sheet)
    pause .2
    Crop((32, 96, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 left:
    Crop((0, 32, 32, 32), char01_sheet)
    pause .2
    Crop((32, 32, 32, 32), char01_sheet)
    pause .2
    Crop((64, 32, 32, 32), char01_sheet)
    pause .2
    Crop((32, 32, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 right:
    Crop((0, 64, 32, 32), char01_sheet)
    pause .2
    Crop((32, 64, 32, 32), char01_sheet)
    pause .2
    Crop((64, 64, 32, 32), char01_sheet)
    pause .2
    Crop((32, 64, 32, 32), char01_sheet)
    pause .2
    repeat


init python:
    class maze_runner:
        def __init__(self):
            self.name = "char01"
            self.speed = 2
            self.cash = 0
            self.hearts = 3
            self.max_hearts = 3
            self.food = 3
            self.max_food = 3
            self.x = 0
            self.y = 0
            self.direction = "up"
            self.stat = "normal"
            self.buff = 0
            self.inventory = ["Idea", "Idea", "Idea"]
            self.recipes = []
            self.game = None
        def update(self):
            if not self.stat == "dead":
                if self.direction == "up" and self.y > -450:
                    self.y -= self.speed + self.buff
                elif self.direction == "down"  and self.y < 410:
                    self.y += self.speed + self.buff
                elif self.direction == "left" and self.x > -850:
                    self.x -= self.speed + self.buff
                elif self.direction == "right" and self.x < 850:
                    self.x += self.speed + self.buff
        def change_direction(self, direction):
            self.direction = direction
        def change_speed(self, speed):
            self.speed += speed
            if self.speed < 1:
                self.speed = 1
        def change_heart(self, h, max = False):
            if max:
                self.max_hearts += h
                if self.max_hearts < 1:
                    self.max_hearts = 1
                    self.hearts = 0
            else:
                self.hearts += h


            if self.hearts > self.max_hearts:
                self.hearts = self.max_hearts
            elif self.hearts < 1:
                self.stat = "dead"
                renpy.show_screen("maze_run_pickup", "Death", self.x, self.y)

        def change_food(self, f, max = False):
            if max:
                self.max_food += f
            if self.max_food < 1:
                self.max_food = 1
                self.food = 0
            else:
                self.food += f

            if self.food > self.max_food:
                self.food = self.max_food
            elif self.food < 1:
                self.food = 0
                self.change_heart(-1)

        def change_stat(self, stat):
            self.stat = stat
            if stat == "Dash":
                self.buff = 4
            elif stat == "normal":
                self.buff = 0

        def eat(self):
            if len(self.inventory):
                item = self.inventory.pop(0)
                renpy.play("maze/bite.ogg", "sound")
                if item == "Speed Up":
                    self.change_speed(1)
                elif item == "Speed Down":
                    self.change_speed(-1)

                elif item == "Heart Potion":
                    self.change_heart(1, True)
                elif item == "Poison":
                    self.change_heart(-1, True)

                elif item == "Pizza":
                    self.change_food(1, True)
                elif item == "Starvation":
                    self.change_food(-1, True)

                elif item == "Hurt":
                    self.change_heart(-1)
                elif item == "Idea":
                    self.change_heart(1)

                elif item == "Food":
                    self.change_food(1)
                elif item == "Fate":
                    self.change_food(-1)

                elif item == "Dash":
                    self.change_stat("Dash")
                elif item == "Recipe":
                    pass
                    for i in self.game.recipes:
                        if not i in self.recipes:
                            self.recipes.append(i)
                            break



    class maze_item:
        def __init__(self, name, x, y, size = .1):
            self.name = name
            self.x = x
            self.y = y
            self.size = size

    class maze:
        def __init__(self, runner):
            self.items_list = [
                "Dash", "Hurt",
                "Idea", "Fate", "Food"
            ]
            self.recipes = [
                [["Dash", "Dash", "Food"], "Speed Up"],
                [["Dash", "Dash", "Hurt"], "Speed Down"],
                
                [["Food", "Dash", "Idea"], "Heart Potion"],
                [["Fate", "Hurt", "Fate"], "Poison"],

                [["Food", "Food", "Idea"], "Pizza"],
                [["Fate", "Fate", "Fate"], "Starvation"],

                # [["Hurt", "Hurt", "Fate"], "Disappointment"],
                # [["Hurt", "Hurt", "Idea"], "Salvation"],


                [["Idea", "Idea", "Idea"], "Recipe"],


            ]
            renpy.random.shuffle(self.recipes)
            self.items = []
            self.runner = runner
            self.runner.game = self
            self.cauldron = []
            self.hunger_skip = 0
            
        def add_item(self, item = None):
            if not item:
                item = renpy.random.choice(self.items_list)
            self.items.append(
                maze_item(
                    item,
                    renpy.random.randint(-800, 800),
                    renpy.random.randint(-400, 400)
                )
            )
            if self.hunger_skip > 10:
                self.runner.change_food(-1)
                self.hunger_skip = 0
            else:
                self.hunger_skip += 1
        def grow(self):
            for i in self.items:
                if i.size < 1.0:
                    i.size += .02

        def check(self):
            for i in self.items:
                if i.x-64 < self.runner.x < i.x+64:
                    if i.y-128 < self.runner.y < i.y-16:
                        if i.size >= 1.0:
                            renpy.play("maze/pluck.ogg", "sound")
                            self.runner.inventory.append(i.name)
                            renpy.show_screen("maze_run_pickup", i.name, self.runner.x, self.runner.y)
                        else:
                            renpy.play("maze/squish.ogg", "sound")
                        self.items.remove(i)
            if self.runner.x > 680 and self.runner.y < -340:
                if len(self.runner.inventory):
                    self.cauldron = self.runner.inventory
                    self.runner.inventory = []

        def brew(self):
            for i in self.recipes:
                if self.cauldron == i[0]:
                    self.items.append(
                        maze_item(
                            i[1],
                            620,
                            -210,
                            1.0
                        )
                    )
                    break
            else:
                self.items.append(
                    maze_item(
                        "Poison",
                        620,
                        -210,
                        1.0
                    )
                )
            self.cauldron = []

        def update(self):
            self.runner.update()
            self.check()


transform maze_run_pickup_anim:
    zoom .1 alpha 1
    ease 1 zoom 2 alpha 0
screen maze_run_pickup(name, x, y):
    text name align .5,.5 offset x,y at maze_run_pickup_anim
    timer 1 action Hide("maze_run_pickup")

default maze_runner_1 = maze_runner()
default maze_1 = maze(maze_runner_1)
screen maze_run(g = maze_1):
    modal True
    key "w" action Function(g.runner.change_direction, "up")
    key "s" action Function(g.runner.change_direction, "down")
    key "a" action Function(g.runner.change_direction, "left")
    key "d" action Function(g.runner.change_direction, "right")
    key "e" action Function(g.runner.eat)
    key "o" action Function(g.runner.change_speed, 1)
    key "p" action Function(g.runner.change_speed, -1)
    
    timer .016 repeat True action Function(g.update)
    if len(g.items) < 20:
        timer renpy.random.randint(1, 5) repeat True action Function(g.add_item)
    timer .15 repeat True action Function(g.grow)
    
    add "maze/bg.png"
    if len(g.cauldron):
        add "maze/cauldron_full.png" align .92,.1
        timer 3 action Function(g.brew)
    else:
        add "maze/cauldron.png" align .92,.1
    frame:
        background "#0009"
        vbox:
            spacing 20
            hbox:
                text "Speed: "
                for i in range(g.runner.speed):
                    add "maze/Speed.png" yoffset 6
            hbox:
                text "Food: "
                for i in range(g.runner.food):
                    add "maze/Foods.png" yoffset 6
                for i in range(g.runner.max_food - g.runner.food):
                    add "maze/Foods_empty.png" yoffset 6
            hbox:
                text "HP: "
                for i in range(g.runner.hearts):
                    add "maze/Heart.png" yoffset 6
                for i in range(g.runner.max_hearts - g.runner.hearts):
                    add "maze/Heart_empty.png" yoffset 6
    for i in g.items:
        button:
            yanchor 1.0
            at bzoom(i.size)
            add "maze/{}.png".format(i.name)
            align .5,.5 offset i.x,i.y
    add g.runner.name + " " + g.runner.direction align .5,.5 offset g.runner.x, g.runner.y at bzoom(3)
    add "maze/fg.png"
    if len(g.runner.inventory):
        frame:
            align 1.0,1.0 offset -100,-100 background "#0009"

            hbox:
                spacing 10 box_reverse True

                for n, i in enumerate(g.runner.inventory):
                    if n == 0:
                        button:
                            xysize 80,80 background "#0009"
                            add "maze/{}.png".format(i) align .5,.5
                            text "Eat" align .5,.5
                            action Function(g.runner.eat)
                    else:
                        frame:
                            xysize 80,80 background "#0009"
                            add "maze/{}.png".format(i) align .5,.5

    if g.runner.stat == "Dash":
        timer 4 repeat True action Function(g.runner.change_stat, "normal")

    frame:
        align 0.0,.5 background "#0009"
        at bzoom(.4)
        vbox:
            text "Recipes" size 60
            for i in g.runner.recipes:
                hbox:
                    for j in i[0]:
                        add "maze/{}.png".format(j)
                    text "=" size 60
                    add "maze/{}.png".format(i[1])

transform brotate(r):
    rotate r
transform bzoom(z):
    subpixel True
    zoom z




        